﻿package com.alecdebusschere.src{
	import flash.display. *;
	import flash.geom. * ;
	import flash.text. * ;
	import flash.events. *;
	import com.alecdebusschere.src.slider.*;
	
	public class SliderB extends Sprite{
		
		public var sliderManager:SliderManager;
		public var scrollDimensions:Rectangle = new  Rectangle();
		private var backgroundBox:Sprite = new Sprite();
		private var knob:Sprite = new Sprite();
		private var bar:Sprite = new Sprite();
		private var minusBut:Sprite = new Sprite();
		private var plusBut:Sprite = new Sprite();
		
		
		public function SliderB(stageW:Number, stageH:Number){
			this.x = stageW-Settings.sliderBoxWidth-Settings.sliderBoxMarginRight;
			this.y = stageH-Settings.sliderBoxHeight-Settings.sliderBoxMarginBottom;
			
			setup();
		}
		public function setup (){
			
			sliderManager= new SliderManager();
			
			drawSlider();
			
			sliderManager.setupSlider(this, this.bar, this.knob, Settings.sliderSteps, Settings.startRatio/Settings.maxRatio*Settings.sliderSteps);
			
			
		}
		internal function updateKnob(step){
			
			sliderManager.updateSliderControl(step);
		}
		internal function moveKnob(step){
			sliderManager.updateSliderControl(sliderManager.currentStep+step);
		}
		internal function stop(e:MouseEvent){
			sliderManager.mouseUpHandler(e);
		}
		private function drawSlider(){
			
			//-
			this.minusBut.graphics.lineStyle(Settings.sliderButtStrokeWeight, Settings.sliderButtStrokeColor);
			this.minusBut.graphics.lineTo(Settings.sliderButtWidth, 0);
			this.minusBut.y = Settings.sliderBoxHeight/2-Settings.sliderButtStrokeWeight/2;
			this.minusBut.x = Settings.sliderBarMarginLeft;
			
			//+
			this.plusBut.graphics.lineStyle(Settings.sliderButtStrokeWeight, Settings.sliderButtStrokeColor);
			this.plusBut.graphics.moveTo(Settings.sliderButtWidth/2, 0);
			this.plusBut.graphics.lineTo(Settings.sliderButtWidth/2, Settings.sliderButtWidth);
			this.plusBut.graphics.moveTo(0, Settings.sliderButtWidth/2);
			this.plusBut.graphics.lineTo(Settings.sliderButtWidth, Settings.sliderButtWidth/2);
			this.plusBut.y = Settings.sliderBoxHeight/2-Settings.sliderButtStrokeWeight/2-Settings.sliderButtWidth/2;
			this.plusBut.x = Settings.sliderBoxWidth-Settings.sliderBarMarginRight-Settings.sliderButtWidth;
			
			//background
			this.backgroundBox.graphics.beginFill(Settings.sliderBoxBackgroundColor);
			this.backgroundBox.graphics.lineStyle(Settings.sliderBoxStrokeWeight, Settings.sliderBoxStrokeColor, Settings.sliderBoxStrokeAlpha);
			this.backgroundBox.graphics.drawRect(0, 0, Settings.sliderBoxWidth, Settings.sliderBoxHeight);
			//bar
			this.bar.graphics.beginFill(Settings.sliderBoxBackgroundColor);
			this.bar.graphics.drawRect(0, -Settings.sliderBoxHeight/2, Settings.sliderBoxWidth-Settings.sliderBarMarginRight*2-Settings.sliderBarMarginLeft*2-Settings.sliderButtWidth*2, Settings.sliderBoxHeight);
			this.bar.graphics.moveTo(0,0);
			this.bar.graphics.lineStyle(Settings.sliderBarStrokeWeight, Settings.sliderBarStrokeColor, Settings.sliderBarStrokeAlpha);
			this.bar.graphics.lineTo(Settings.sliderBoxWidth-Settings.sliderBarMarginRight*2-Settings.sliderBarMarginLeft*2-Settings.sliderButtWidth*2, 0);
			this.bar.y = Settings.sliderBarMarginTop;
			this.bar.x = Settings.sliderButtWidth+Settings.sliderBarMarginLeft*2;
			//knob
			this.knob.graphics.beginFill(Settings.sliderKnobBackgroundColor);
			this.knob.graphics.lineStyle(Settings.sliderKnobStrokeWeight, Settings.sliderKnobStrokeColor, Settings.sliderKnobStrokeAlpha);
			this.knob.graphics.drawRect(0, 0, Settings.sliderKnobWidth, Settings.sliderKnobHeight);
			this.knob.x = Settings.sliderButtWidth+Settings.sliderBarMarginLeft*2;
			this.knob.y = Settings.sliderBarMarginTop-Settings.sliderKnobHeight/2;
			addChild(this.backgroundBox);
			addChild(this.minusBut);
			addChild(this.plusBut);
			addChild(this.bar);
			addChild(this.knob);
			
		}
			
	}
}
