﻿package com.alecdebusschere.src.drawUtils{
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.display.LineScaleMode;
	import flash.display.CapsStyle;
	import flash.display.JointStyle;
	public class DashedCircle extends Sprite{
		
		private var shape:Shape;
		
		        
		public function DashedCircle(radius:int, strokeWeight:int = 1, dashLength:int = 1, strokeColor:uint = 0x000000, strokeAlpha:Number = 1, background:Boolean = false, backgroundColor:uint = 0, backgroundAlpha:Number = 1):void{
			
			if(background){
				
				shape = new Shape();
				shape.graphics.beginFill(backgroundColor, backgroundAlpha);
				shape.graphics.drawCircle(0, 0, radius);
				addChild(shape);
			}
			var circ = Math.PI * radius * 2;
			var nbDashes = Math.floor(circ/dashLength/2);
			
			var spaceLength = (circ-nbDashes*dashLength)/nbDashes;
			
			
			
			for(var i:Number=0;i<nbDashes;i++){
				var startAngle = (i*(dashLength+spaceLength))/circ*360;
				var endAngle = startAngle+dashLength/circ*360;
				startAngle = (startAngle/180)*Math.PI;
				endAngle = (endAngle/180)*Math.PI;
				
				//start point
				var ax:Number = Math.cos(startAngle)*radius;
				var ay:Number = Math.sin(startAngle)*radius;
			
				//end point
				var bx:Number = Math.cos(endAngle)*radius;
				var by:Number = Math.sin(endAngle)*radius;
			
				var dash:Shape = new Shape();
				
				dash.graphics.lineStyle(strokeWeight, strokeColor, strokeAlpha);
				dash.graphics.moveTo(ax, ay);
				dash.graphics.lineTo(bx, by);
				addChild(dash);
			}
			
			           
		}
	}
}