﻿package com.alecdebusschere.src.slider{
	
	import flash.text.*;
	import flash.display. *;
	import flash.events. *;
	import flash.geom. * ;
	import 	flash.ui.*;
	
	public class SliderManager extends MovieClip{
		
		private var dragRect:Rectangle = new Rectangle();
		private var holder:Sprite;
		private var sliderBar:Sprite;
		public var sliderControl:Sprite;
		private var snapping:int;
		public var currentStep:int;
		private var barSteps:int;
		private var textBox:TextField;
		
		public function SliderManager(){
		
		}
		//_sliderManagerRef.setupSlider(this,scrollDimensions,sliderBar,horizontalScrollControl,verticalScrollBar,verticalScrollControl)
		public function setupSlider (_holder:Sprite,  _sliderBar:Sprite,_sliderControl:Sprite,_snapping:int =25,defaultVal:int =0,_textBox:TextField = null) {
			holder = _holder;
			sliderBar = _sliderBar;
			sliderControl = _sliderControl;
			sliderControl.buttonMode = true;
			
			sliderBar.buttonMode = true;
			
			textBox = _textBox;
			
		
			snapping = _snapping;
			barSteps =	Math.round(sliderBar.width/snapping);
			
			
			dragRect.x = sliderBar.x;
			dragRect.y = sliderControl.y;
			dragRect.width = sliderBar.width-sliderControl.width;
			dragRect.height = 0;
			
			//sliderControl.y = dragRect.y
			sliderBar.addEventListener(MouseEvent.CLICK, mouseClickHandler);
			sliderControl.addEventListener(MouseEvent.MOUSE_DOWN, mouseDownHandler);
			holder.addEventListener(MouseEvent.MOUSE_UP,mouseUpHandler);

			holder.addEventListener(MouseEvent.ROLL_OUT, mouseUpHandler);
			updateSliderControl(defaultVal);
			
			
		}
		
		public function updateSliderControl(val){
			if (val*barSteps>sliderBar.width-sliderControl.width){
				
				val = snapping;
				
			}
			
			else if(val < 0) val = 0;
			this.currentStep = val;
			
			if((barSteps *  val) + dragRect.x > dragRect.x+sliderBar.width-sliderControl.width)
				sliderControl.x = dragRect.x+sliderBar.width-sliderControl.width;
			else
				sliderControl.x = (barSteps *  val) + dragRect.x;
			
		}
		
		
		private function mouseDownHandler(e:MouseEvent):void {
			
			sliderControl.startDrag(false, dragRect);
			holder.addEventListener(MouseEvent.MOUSE_MOVE,sliderMovesHandler);
		}
		private function sliderMovesHandler(e:MouseEvent):void {
			
			var data:Object = new Object();
			this.currentStep = Math.round((sliderControl.x - sliderBar.x) / barSteps);
			data.step = this.currentStep;
			
			holder.dispatchEvent(new SliderEvent(SliderEvent.SLIDER_MOVES,true, data));
			
		}
		
		private function mouseClickHandler(e:MouseEvent):void{
			if(e.localX > sliderControl.x + sliderControl.width-sliderBar.x){
				updateSliderControl(this.currentStep +1);
			}
			else if(e.localX < sliderControl.x){
				updateSliderControl(this.currentStep - 1);
			}
			else return;
			
			sliderMovesHandler(e);
		}
		
		public function mouseUpHandler(e:MouseEvent):void {
			
			holder.dispatchEvent(new SliderEvent(SliderEvent.SLIDER_UPDATED,true));
			
			holder.removeEventListener(MouseEvent.MOUSE_MOVE,sliderMovesHandler);
			holder.removeEventListener(MouseEvent.MOUSE_MOVE,mouseUpHandler);
			
			stopDrag();
		}
		
		
	}
}
